"use strict";

function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _react = _interopRequireWildcard(require("react"));
var _Explanation = _interopRequireDefault(require("./Explanation"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && Object.prototype.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
var renderMessageForCorrectAnswer = function renderMessageForCorrectAnswer(question) {
  var defaultMessage = 'You are correct. Please click Next to continue.';
  return question.messageForCorrectAnswer || defaultMessage;
};
var renderMessageForIncorrectAnswer = function renderMessageForIncorrectAnswer(question) {
  var defaultMessage = 'Incorrect answer. Please try again.';
  return question.messageForIncorrectAnswer || defaultMessage;
};
var InstantFeedback = function InstantFeedback(_ref) {
  var showInstantFeedback = _ref.showInstantFeedback,
    incorrectAnswer = _ref.incorrectAnswer,
    correctAnswer = _ref.correctAnswer,
    question = _ref.question,
    onQuestionSubmit = _ref.onQuestionSubmit,
    userAnswer = _ref.userAnswer;
  (0, _react.useEffect)(function () {
    if (onQuestionSubmit && (correctAnswer || incorrectAnswer)) {
      onQuestionSubmit({
        question: question,
        userAnswer: userAnswer,
        isCorrect: correctAnswer
      });
    }
  }, [correctAnswer, incorrectAnswer]);
  return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, incorrectAnswer && showInstantFeedback && /*#__PURE__*/_react["default"].createElement("div", {
    className: "alert incorrect"
  }, renderMessageForIncorrectAnswer(question)), correctAnswer && showInstantFeedback && /*#__PURE__*/_react["default"].createElement("div", {
    className: "alert correct"
  }, renderMessageForCorrectAnswer(question), /*#__PURE__*/_react["default"].createElement(_Explanation["default"], {
    question: question,
    isResultPage: false
  })));
};
var _default = exports["default"] = InstantFeedback;