"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _react = _interopRequireDefault(require("react"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
var ProgressBar = function ProgressBar(_ref) {
  var currentQuestion = _ref.currentQuestion,
    totalQuestions = _ref.totalQuestions;
  var progress = currentQuestion / totalQuestions * 100;
  var remainingQuestions = totalQuestions - currentQuestion;

  // Inline styles for the progress bar
  var progressBarContainerStyles = {
    position: 'relative',
    marginBottom: '20px'
  };
  var progressBarStyles = {
    backgroundColor: 'white',
    height: '20px',
    width: '100%',
    maxWidth: '4xl',
    borderRadius: '50px',
    position: 'relative'
  };
  var fillStyles = {
    backgroundColor: 'red',
    height: '20px',
    borderRadius: '50px',
    width: "".concat(progress, "%"),
    transition: 'width 1s ease-in-out'
  };
  var textStyles = {
    position: 'absolute',
    top: '0',
    left: '0',
    right: '0',
    bottom: '0',
    display: 'flex',
    alignItems: 'center',
    justifyContent: 'center',
    color: 'black'
  };

  // Inline styles for question count

  return /*#__PURE__*/_react["default"].createElement("div", {
    style: progressBarContainerStyles
  }, /*#__PURE__*/_react["default"].createElement("div", {
    style: progressBarStyles
  }, /*#__PURE__*/_react["default"].createElement("div", {
    style: fillStyles
  }, /*#__PURE__*/_react["default"].createElement("span", {
    style: textStyles
  }, progress, "%"))));
};
var _default = exports["default"] = ProgressBar;